(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/forms'), require('@angular/core')) :
    typeof define === 'function' && define.amd ? define('ngx-reactive-form', ['exports', '@angular/forms', '@angular/core'], factory) :
    (global = global || self, factory(global['ngx-reactive-form'] = {}, global.ng.forms, global.ng.core));
}(this, (function (exports, forms, core) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __exportStar(m, exports) {
        for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
        if (m) return m.call(o);
        return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @record
     */
    function DependentValidatorBuilder() { }
    if (false) {
        /**
         * @return {?}
         */
        DependentValidatorBuilder.prototype.affectedControls = function () { };
        /**
         * @return {?}
         */
        DependentValidatorBuilder.prototype.validate = function () { };
        /**
         * @return {?}
         */
        DependentValidatorBuilder.prototype.inverse = function () { };
    }
    /**
     * @record
     * @template T
     */
    function DependentValidatorBuilderRoot() { }
    if (false) {
        /**
         * @param {?} firstBuilder
         * @param {?} secondBuilder
         * @param {...?} builders
         * @return {?}
         */
        DependentValidatorBuilderRoot.prototype.all = function (firstBuilder, secondBuilder, builders) { };
        /**
         * @param {?} firstBuilder
         * @param {?} secondBuilder
         * @param {...?} builders
         * @return {?}
         */
        DependentValidatorBuilderRoot.prototype.any = function (firstBuilder, secondBuilder, builders) { };
        /**
         * @param {?} predicate
         * @param {?} firstPath
         * @param {...?} paths
         * @return {?}
         */
        DependentValidatorBuilderRoot.prototype.validator = function (predicate, firstPath, paths) { };
    }
    /**
     * @record
     */
    function DependentValidator() { }
    if (false) {
        /**
         * @return {?}
         */
        DependentValidator.prototype.reset = function () { };
        /**
         * @template THIS
         * @this {THIS}
         * @param {?} path
         * @param {?} firstValidator
         * @param {...?} validators
         * @return {THIS}
         */
        DependentValidator.prototype.applyValidator = function (path, firstValidator, validators) { };
        /**
         * @param {?} firstValidator
         * @param {...?} validators
         * @return {?}
         */
        DependentValidator.prototype.createValidator = function (firstValidator, validators) { };
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @template T
     * @param {?} factory
     * @param {?=} destroy
     * @return {?}
     */
    function lazy(factory, destroy) {
        /** @type {?} */
        var init = false;
        /** @type {?} */
        var lVal;
        /** @type {?} */
        var err;
        /**
         * @return {?}
         */
        function value() {
            if (!init) {
                init = true;
                try {
                    lVal = factory();
                }
                catch (e) {
                    err = e;
                }
            }
            if (err) {
                throw err;
            }
            return lVal;
        }
        value.reset = (/**
         * @return {?}
         */
        function () {
            if (init) {
                err = undefined;
                if (typeof destroy === 'function') {
                    destroy(lVal);
                }
                init = false;
            }
        });
        value.isInit = (/**
         * @return {?}
         */
        function () { return init; });
        return value;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} control
     * @param {...?} ps
     * @return {?}
     */
    function traverseControl(control) {
        var ps = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            ps[_i - 1] = arguments[_i];
        }
        if (ps.length === 0 || !control) {
            return control;
        }
        if (control instanceof forms.FormGroup || control instanceof forms.FormArray) {
            var _a = __read(ps), p = _a[0], lps = _a.slice(1);
            return traverseControl.apply(void 0, __spread([control.controls[p]], lps));
        }
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} ctrls
     * @return {?}
     */
    function getElements(ctrls) {
        return Array.isArray(ctrls) ? ctrls :
            typeof ctrls === 'object' && Object.values(ctrls) || [];
    }
    /**
     * @param {?} root
     * @param {?} action
     * @param {?} updateState
     * @return {?}
     */
    function tapControls(root, action, updateState) {
        var e_1, _a;
        try {
            for (var _b = __values(getElements(root && root.controls)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var ctrl = _c.value;
                if (ctrl instanceof forms.FormGroup || ctrl instanceof forms.FormArray) {
                    tapControls(ctrl, action, updateState);
                    continue;
                }
                if (typeof action === 'function') {
                    action(ctrl);
                }
                if (updateState) {
                    ctrl.updateValueAndValidity();
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @template T
     * @param {?} items
     * @return {?}
     */
    function uniq(items) {
        return (items || []).filter((/**
         * @param {?} val
         * @param {?} idx
         * @param {?} self
         * @return {?}
         */
        function (val, idx, self) { return val && self.indexOf(val) === idx; }));
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DependentValidatorBuilderImpl = /** @class */ (function () {
        function DependentValidatorBuilderImpl(affectedControls, validate) {
            this.affectedControls = affectedControls;
            this.validate = validate;
        }
        /**
         * @return {?}
         */
        DependentValidatorBuilderImpl.prototype.inverse = /**
         * @return {?}
         */
        function () {
            var _this = this;
            return new DependentValidatorBuilderImpl(this.affectedControls, (/**
             * @return {?}
             */
            function () { return !_this.validate(); }));
        };
        return DependentValidatorBuilderImpl;
    }());
    if (false) {
        /** @type {?} */
        DependentValidatorBuilderImpl.prototype.affectedControls;
        /** @type {?} */
        DependentValidatorBuilderImpl.prototype.validate;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @template T
     */
    var /**
     * @template T
     */
    DependentValidatorBuilderRootImpl = /** @class */ (function () {
        function DependentValidatorBuilderRootImpl(form) {
            this.form = form;
        }
        /**
         * @param {...?} builders
         * @return {?}
         */
        DependentValidatorBuilderRootImpl.prototype.all = /**
         * @param {...?} builders
         * @return {?}
         */
        function () {
            var builders = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                builders[_i] = arguments[_i];
            }
            return new DependentValidatorBuilderImpl((/**
             * @return {?}
             */
            function () { return uniq([].concat(builders.map((/**
             * @param {?} b
             * @return {?}
             */
            function (b) { return b.affectedControls(); })))); }), (/**
             * @return {?}
             */
            function () { return builders.every((/**
             * @param {?} b
             * @return {?}
             */
            function (b) { return b.validate(); })); }));
        };
        /**
         * @param {...?} builders
         * @return {?}
         */
        DependentValidatorBuilderRootImpl.prototype.any = /**
         * @param {...?} builders
         * @return {?}
         */
        function () {
            var builders = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                builders[_i] = arguments[_i];
            }
            return new DependentValidatorBuilderImpl((/**
             * @return {?}
             */
            function () { return uniq([].concat(builders.map((/**
             * @param {?} b
             * @return {?}
             */
            function (b) { return b.affectedControls(); })))); }), (/**
             * @return {?}
             */
            function () { return builders.some((/**
             * @param {?} b
             * @return {?}
             */
            function (b) { return b.validate(); })); }));
        };
        /**
         * @param {?} predicate
         * @param {?} firstPath
         * @param {...?} paths
         * @return {?}
         */
        DependentValidatorBuilderRootImpl.prototype.validator = /**
         * @param {?} predicate
         * @param {?} firstPath
         * @param {...?} paths
         * @return {?}
         */
        function (predicate, firstPath) {
            var _this = this;
            var paths = [];
            for (var _i = 2; _i < arguments.length; _i++) {
                paths[_i - 2] = arguments[_i];
            }
            /** @type {?} */
            var formFn = lazy((/**
             * @return {?}
             */
            function () { return _this.form(); }));
            /** @type {?} */
            var ctrlFn = lazy((/**
             * @return {?}
             */
            function () {
                if (typeof firstPath === 'string' || typeof firstPath === 'number') {
                    return traverseControl.apply(void 0, __spread([formFn(), firstPath], paths));
                }
                else if (typeof firstPath === 'function') {
                    return firstPath(formFn());
                }
            }));
            return new DependentValidatorBuilderImpl((/**
             * @return {?}
             */
            function () { return [ctrlFn()]; }), (/**
             * @return {?}
             */
            function () {
                /** @type {?} */
                var ctrl = ctrlFn();
                return ctrl && typeof predicate === 'function' && predicate(ctrl.value, formFn());
            }));
        };
        return DependentValidatorBuilderRootImpl;
    }());
    if (false) {
        /**
         * @type {?}
         * @private
         */
        DependentValidatorBuilderRootImpl.prototype.form;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @template T
     */
    var /**
     * @template T
     */
    DependentValidatorImpl = /** @class */ (function () {
        function DependentValidatorImpl(rootFn, builderFn) {
            var _this = this;
            this.rootFn = rootFn;
            this.builderFn = builderFn;
            this.builder = lazy((/**
             * @return {?}
             */
            function () {
                if (typeof _this.builderFn === 'function') {
                    /** @type {?} */
                    var builderRoot = new DependentValidatorBuilderRootImpl((/**
                     * @return {?}
                     */
                    function () { return _this.rootFn(); }));
                    return _this.builderFn(builderRoot);
                }
            }));
            this.subscribedControls = [];
            this.subscription = lazy((/**
             * @return {?}
             */
            function () {
                return _this.builder().affectedControls()
                    .filter((/**
                 * @param {?} item
                 * @return {?}
                 */
                function (item) { return !!item; })).map((/**
                 * @param {?} item
                 * @return {?}
                 */
                function (item) { return item
                    .valueChanges.subscribe((/**
                 * @return {?}
                 */
                function () { return _this.subscribedControls
                    .forEach((/**
                 * @param {?} control
                 * @return {?}
                 */
                function (control) { return control.updateValueAndValidity(); })); })); }));
            }), (/**
             * @param {?} subs
             * @return {?}
             */
            function (subs) { return subs.forEach((/**
             * @param {?} s
             * @return {?}
             */
            function (s) { return s.unsubscribe(); })); }));
        }
        /**
         * @return {?}
         */
        DependentValidatorImpl.prototype.reset = /**
         * @return {?}
         */
        function () {
            this.builder.reset();
            this.subscription.reset();
        };
        /**
         * @template THIS
         * @this {THIS}
         * @param {?} path
         * @param {...?} validators
         * @return {THIS}
         */
        DependentValidatorImpl.prototype.applyValidator = /**
         * @template THIS
         * @this {THIS}
         * @param {?} path
         * @param {...?} validators
         * @return {THIS}
         */
        function (path) {
            var validators = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                validators[_i - 1] = arguments[_i];
            }
            /** @type {?} */
            var paths = Array.isArray(path) ? path : [path];
            /** @type {?} */
            var ctrl = traverseControl.apply(void 0, __spread([(/** @type {?} */ (this)).rootFn()], paths));
            if (ctrl) {
                ctrl.setValidators((/** @type {?} */ (this)).createValidator.apply((/** @type {?} */ (this)), __spread(validators)));
            }
            return (/** @type {?} */ (this));
        };
        /**
         * @param {...?} validators
         * @return {?}
         */
        DependentValidatorImpl.prototype.createValidator = /**
         * @param {...?} validators
         * @return {?}
         */
        function () {
            var _this = this;
            var validators = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                validators[_i] = arguments[_i];
            }
            /** @type {?} */
            var validate = forms.Validators.compose(validators);
            /** @type {?} */
            var ctrlSubscribed = false;
            return (/**
             * @param {?} ctrl
             * @return {?}
             */
            function (ctrl) {
                /** @type {?} */
                var builder;
                if (!ctrlSubscribed) {
                    ctrlSubscribed = true;
                    if (_this.subscribedControls.indexOf(ctrl) === -1) {
                        _this.subscribedControls.push(ctrl);
                    }
                }
                if (!_this.subscription.isInit() && _this.rootFn()) {
                    builder = _this.builder();
                    _this.subscription();
                }
                else if (_this.builder.isInit()) {
                    builder = _this.builder();
                }
                return (!builder || builder.validate()) ? validate(ctrl) : null;
            });
        };
        return DependentValidatorImpl;
    }());
    if (false) {
        /**
         * @type {?}
         * @private
         */
        DependentValidatorImpl.prototype.builder;
        /**
         * @type {?}
         * @private
         */
        DependentValidatorImpl.prototype.subscribedControls;
        /**
         * @type {?}
         * @private
         */
        DependentValidatorImpl.prototype.subscription;
        /**
         * @type {?}
         * @private
         */
        DependentValidatorImpl.prototype.rootFn;
        /**
         * @type {?}
         * @private
         */
        DependentValidatorImpl.prototype.builderFn;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @template T
     */
    var   /**
     * @template T
     */
    FormUtils = /** @class */ (function () {
        function FormUtils(rootFn) {
            var _this = this;
            this.rootFn = rootFn;
            this._root = lazy((/**
             * @return {?}
             */
            function () {
                if (_this.rootFn instanceof forms.FormGroup || _this.rootFn instanceof forms.FormArray) {
                    return _this.rootFn;
                }
                else if (typeof _this.rootFn === 'function') {
                    return _this.rootFn();
                }
            }));
        }
        Object.defineProperty(FormUtils.prototype, "root", {
            get: /**
             * @return {?}
             */
            function () {
                /** @type {?} */
                var r = this._root;
                if (!r()) {
                    r.reset();
                }
                return (/** @type {?} */ (r()));
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?=} action
         * @param {?=} updateState
         * @return {?}
         */
        FormUtils.prototype.tapControls = /**
         * @param {?=} action
         * @param {?=} updateState
         * @return {?}
         */
        function (action, updateState) {
            if (updateState === void 0) { updateState = true; }
            tapControls(this.root, action, updateState);
        };
        /**
         * @param {?} builderFn
         * @return {?}
         */
        FormUtils.prototype.createDependentValidator = /**
         * @param {?} builderFn
         * @return {?}
         */
        function (builderFn) {
            var _this = this;
            return new DependentValidatorImpl((/**
             * @return {?}
             */
            function () { return _this.root; }), builderFn);
        };
        /**
         * @return {?}
         */
        FormUtils.prototype.makePristine = /**
         * @return {?}
         */
        function () {
            this.tapControls((/**
             * @param {?} ctrl
             * @return {?}
             */
            function (ctrl) {
                ctrl.markAsPristine();
                ctrl.markAsUntouched();
            }));
        };
        /**
         * @return {?}
         */
        FormUtils.prototype.makeDirty = /**
         * @return {?}
         */
        function () {
            this.tapControls((/**
             * @param {?} ctrl
             * @return {?}
             */
            function (ctrl) {
                ctrl.markAsDirty();
                ctrl.markAsTouched();
            }));
        };
        return FormUtils;
    }());
    if (false) {
        /**
         * @type {?}
         * @private
         */
        FormUtils.prototype._root;
        /**
         * @type {?}
         * @private
         */
        FormUtils.prototype.rootFn;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @template T
     */
    var /**
     * @template T
     */
    ExtendedFormBuilderResult = /** @class */ (function () {
        function ExtendedFormBuilderResult(fb, factory) {
            var _this = this;
            this.fb = fb;
            this.factory = factory;
            this.validators = [];
            this._formUtils = lazy((/**
             * @return {?}
             */
            function () { return new FormUtils((/**
             * @return {?}
             */
            function () { return _this.form; })); }));
            this.form = this.factory(this.fb, (/**
             * @param {?} dv
             * @return {?}
             */
            function (dv) {
                /** @type {?} */
                var v = _this.formUtils.createDependentValidator(dv);
                _this.validators.push(v);
                return v;
            }));
        }
        Object.defineProperty(ExtendedFormBuilderResult.prototype, "formUtils", {
            get: /**
             * @return {?}
             */
            function () {
                return this._formUtils();
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        ExtendedFormBuilderResult.prototype.updateValidators = /**
         * @return {?}
         */
        function () {
            this.validators.forEach((/**
             * @param {?} item
             * @return {?}
             */
            function (item) { return item.reset(); }));
            this.formUtils.tapControls();
        };
        return ExtendedFormBuilderResult;
    }());
    if (false) {
        /**
         * @type {?}
         * @private
         */
        ExtendedFormBuilderResult.prototype.validators;
        /**
         * @type {?}
         * @private
         */
        ExtendedFormBuilderResult.prototype._formUtils;
        /** @type {?} */
        ExtendedFormBuilderResult.prototype.form;
        /**
         * @type {?}
         * @private
         */
        ExtendedFormBuilderResult.prototype.fb;
        /**
         * @type {?}
         * @private
         */
        ExtendedFormBuilderResult.prototype.factory;
    }
    var ExtendedFormBuilder = /** @class */ (function () {
        function ExtendedFormBuilder(fb) {
            this.fb = fb;
        }
        /**
         * @template T
         * @param {?} factory
         * @return {?}
         */
        ExtendedFormBuilder.prototype.build = /**
         * @template T
         * @param {?} factory
         * @return {?}
         */
        function (factory) {
            return new ExtendedFormBuilderResult(this.fb, factory);
        };
        ExtendedFormBuilder.decorators = [
            { type: core.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        ExtendedFormBuilder.ctorParameters = function () { return [
            { type: forms.FormBuilder }
        ]; };
        /** @nocollapse */ ExtendedFormBuilder.ngInjectableDef = core.defineInjectable({ factory: function ExtendedFormBuilder_Factory() { return new ExtendedFormBuilder(core.inject(forms.FormBuilder)); }, token: ExtendedFormBuilder, providedIn: "root" });
        return ExtendedFormBuilder;
    }());
    if (false) {
        /**
         * @type {?}
         * @private
         */
        ExtendedFormBuilder.prototype.fb;
    }

    exports.ExtendedFormBuilder = ExtendedFormBuilder;
    exports.FormUtils = FormUtils;
    exports.tapControls = tapControls;
    exports.traverseControl = traverseControl;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-reactive-form.umd.js.map
